TEMPLATE = lib
CONFIG += dll

include(../plugins.pri)

win32:{
    AVS:X32:TARGET = ../../release/plugins/svpflow1
    AVS:X64:TARGET = ../../release/plugins64/svpflow1
    VS:X32:TARGET = ../../release/plugins/svpflow1_vs
    VS:X64:TARGET = ../../release/plugins64/svpflow1_vs
}
unix:{
    !ARM:TARGET = ../release/svpflow1
    ARM:TARGET = ../release/svpflow1_arm
}

INCLUDEPATH += ../jsoncpp/include ../include
!win32:LIBS += -L../release -ljsoncpp
win32:LIBS += -L../release -llibjsoncpp

SOURCES += \
	planeofblocks.cpp \
	mvsuper.cpp \
	mvframe.cpp \
	mvanalyse.cpp \
	exports.cpp \
	groupofplanes.cpp \
	search.cpp \
	x264_pixel.cpp \
	x264_cpu.cpp \
	remotecontrol.cpp \
	mvframe_interpolation.cpp \
	blockmath.cpp \
	basefilter.cpp        

HEADERS += \
	version.h \
	planeofblocks.h \
	mvsuper.h \
	mvanalyse.h \
	groupofplanes.h \
	common.h \
	x264_pixel.h \
	remotecontrol.h \
	mvframe.h \
	mvframe_interpolation.h \
	blockmath.h \
	basefilter.h

contains(DEFINES,AVISYNTH_PLUGIN) {
	HEADERS += avisynth.h vectorsconverter.h
	SOURCES += vectorsconverter.cpp
}

!ARM {
    ASM_FILES = \
        x86\const-a.asm \
        x86\cpu-a.asm \
        x86\pixel-a.asm \
        x86\sad-a.asm \
        x86\x86inc.asm \
        x86\x86util.asm
    X32: ASM_FILES += x86\bilinear.asm x86\pixel-32.asm

    win32:X32:asmproc.commands = nasm -f win32 -w-macro-params-legacy -DARCH_X86_64=0 -DPREFIX -DHIGH_BIT_DEPTH=0 -DBIT_DEPTH=8 -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN}
    win32:X64:asmproc.commands = nasm -f win64 -w-macro-params-legacy -DARCH_X86_64=1 -DHIGH_BIT_DEPTH=0 -DBIT_DEPTH=8 -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN}
    unix:!macx:X32:asmproc.commands = nasm -f elf32 -DARCH_X86_64=0 -DHIGH_BIT_DEPTH=0 -DBIT_DEPTH=8 -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN}
    unix:!macx:X64:asmproc.commands = nasm -f elf64 -DARCH_X86_64=1 -DHIGH_BIT_DEPTH=0 -DBIT_DEPTH=8 -DPIC -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN}
    unix:macx:X64:asmproc.commands = nasm -f macho64 -DPREFIX -DPIC -DARCH_X86_64=1 -DHIGH_BIT_DEPTH=0 -DBIT_DEPTH=8 -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN}
}
ARM: {
    !android:ASM_FILES = \
        arm64\pixel-a.S \
        arm64\asm.S
    android:ASM_FILES = \
        android64\pixel-a.S \
        android64\asm.S

    !android: asmproc.commands = clang -DPREFIX -DPIC -c -DSTACK_ALIGNMENT=16 -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN}
    android: SOURCES += $$ASM_FILES
}
!android {
    asmproc.output = ${QMAKE_FILE_BASE}.obj
    asmproc.input = ASM_FILES
    QMAKE_EXTRA_COMPILERS += asmproc
}

OTHER_FILES +=
RC_FILE = svpflow1.rc
