/**************************************************************
SVPFlow1 - motion vectors search for SmoothVideo Project (SVP)
Copyright(c)2016 Chainik - http://www.svp-team.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
http://www.gnu.org/copyleft/gpl.html
*****************************************************************/

#pragma once

#include "mvframe.h"

#ifdef AVISYNTH_PLUGIN

class VectorsConverter:public GenericVideoFilter
{
protected:
    struct AnalysisData //MVAnalusisData from MVTools
    {
        int nMagicKey; // placed to head in v.1.2.6
        int nVersion; // MVAnalysisData and outfile format version - added in v1.2.6
        int nBlkSizeX; // horizontal block size
        int nBlkSizeY; // vertical block size - v1.7
        int nPel;
        int nLvCount;
        int nDeltaFrame;
        bool isBackward;
        int nFlags;
        int nWidth;
        int nHeight;
        int nOverlapX; // overlap block size - v1.1
        int nOverlapY; // vertical overlap - v1.7
        int nBlkX; // number of blocks along X
        int nBlkY; // number of blocks along Y
        int pixelType; // color format
        int yRatioUV; // ratio of luma plane height to chroma plane height
        int xRatioUV; // ratio of luma plane height to chroma plane width (fixed to 2 for YV12 and YUY2)
        int nHPadding; // Horizontal padding - v1.8.1
        int nVPadding; // Vertical padding - v1.8.1
    };

    AnalysisData ad;
    int headerSize;

public:
    VectorsConverter(PClip child,bool isb,IScriptEnvironment* env);
    virtual ~VectorsConverter();

    PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

#endif
